# importing libraries
#Librairie interface:
from PyQt5.QtWidgets import *
from PyQt5 import QtCore, QtGui
from PyQt5.QtGui import *
from PyQt5.QtCore import *
import sys

#Librairie lien nucléo :
from serial import Serial
import serial.tools.list_ports

from PyQt5.uic import loadUi

class Window(QMainWindow):

    def __init__(self):
        super().__init__()

        # setting title
        self.setWindowTitle("Robot Véronica")

        # setting geometry
        self.setGeometry(100, 100, 600, 400)

        # calling method
        self.UiComponents()

        # showing all the widgets
        self.show()

        # To obtain the list of the communication ports
        self.ports = serial.tools.list_ports.comports()
        self.ports.sort()

        # To clear the list on the window
        #self.ports.clear()
        # To add all the communication ports to the list
        for port, desc, hwid in sorted(self.ports):
            print(f"{port} [{desc}]")

        self.selectPort = 16 #input('COM ?'), A REMPLIR AVANT DE LANCER LE PROGRAMME

        # To create an empty serial connection
        self.serNuc = Serial()
        self.connected = 0
        self.connectToNucleo()
        self.value = 0
        self.value2 = 0
        self.mesure_humidite = 0
        self.mesure_temp = 0

        #Connexion du bouton
        self.button_distance.clicked.connect(self.Envoiedonnees_distance)
        self.button_angle.clicked.connect(self.Envoiedonnees_angle)
        self.button_recup_mesure.clicked.connect(self.affiche_mesure)

    # method for widgets
    def UiComponents(self):
        # Curseur pour la distance
        self.spin = QSpinBox(self)
        self.spin.setRange(-99, 99)
        self.spin.setSingleStep(1)
        self.spin.setSuffix(' cm')

        # setting geometry to spin box
        self.spin.setGeometry(100, 100, 100, 40)

        # adding action to the spin box
        self.spin.valueChanged.connect(self.show_result)

        # creating label show result
        self.label = QLabel(self)

        # setting geometry
        self.label.setGeometry(100, 200, 200, 40)

        # Curseur pour l'angle

        # creating spin box2
        self.spin2 = QSpinBox(self)

        self.spin2.setRange(-99, 99)
        self.spin2.setSingleStep(1)
        self.spin2.setSuffix(' °')

        # setting geometry to spin box
        self.spin2.setGeometry(300, 100, 100, 40)

        # adding action to the spin box
        self.spin2.valueChanged.connect(self.show_result2)

        # creating label show result
        self.label2 = QLabel(self)

        # setting geometry
        self.label2.setGeometry(300, 200, 200, 40)

        # creating label show result
        self.label3 = QLabel(self)

        # setting geometry
        self.label3.setGeometry(250, 300, 200, 40)


        self.button_distance = QPushButton('Envoi', self)
        self.setToolTip('This is an example button')
        self.button_distance.move(100,70)

        self.button_angle = QPushButton('Envoi', self)
        self.setToolTip('This is an example button')
        self.button_angle.move(300,70)

        self.button_recup_mesure = QPushButton('Mesure', self)
        self.setToolTip('This is an example button')
        self.button_recup_mesure.move(200,200)

    def __del__(self):
        self.serNuc.close()

    def connectToNucleo(self):
        if(self.connected == 0):
            self.serNuc = Serial("COM"+str(self.selectPort), 115200)
            self.connected = 1

    def quitApp(self):
        self.serNuc.close()
        self.close()

    def Envoiedonnees_distance(self): #Fonction d'envoi des données de distance
        print(self.connected)
        if(self.connected):
            print(str(self.value))
            self.serNuc.write(bytes('0', 'utf-8'))
            if (self.value>0):
                self.serNuc.write(bytes('1', 'utf-8')) #avancer
            else:
                self.serNuc.write(bytes('0','utf-8')) #reculer
            self.serNuc.write(bytes(str(abs(self.value)),'utf-8'))

    def Envoiedonnees_angle(self): #Fonction d'envoi des données de rotation
        print(self.connected)
        if(self.connected):
            print(str(self.value2))
            self.serNuc.write(bytes('1','utf-8'))
            if (self.value>0):
                self.serNuc.write(bytes('1', 'utf-8'))
            else:
                self.serNuc.write(bytes('0','utf-8'))
            self.serNuc.write(bytes(str(abs(self.value2)),'utf-8'))

    #fonction qui récupère la distance à parcourir
    def show_result(self):
        # getting current value
        self.value = self.spin.value()
        # setting value of spin box to the label
        self.label.setText("Distance : " + str(self.value))

    # fonction qui récupère l'angle
    def show_result2(self):
        # getting current value
        self.value2 = self.spin2.value()
        # setting value of spin box to the label
        self.label2.setText("Angle : " + str(self.value2))

    #fonction qui récupère les mesures :
    def affiche_mesure(self):
        while(self.serNuc.in_waiting == 0):
            print("Wait !")
        rec_data_nucleo = self.serNuc.read(2)
        self.mesure_humidite = rec_data_nucleo[0]
        self.mesure_temp = rec_data_nucleo[1]
        print(f'Température = {rec_data_nucleo[0]}')
        print(f'Humidité = {rec_data_nucleo[1]}')


# create pyqt5 app
App = QApplication(sys.argv)
# create the instance of our Window
window = Window()
window.show()

# start the app
sys.exit(App.exec())