#include "mbed.h"
#include "MOD24_NRF.h"
#include "nRF24.h"

Serial          debug_pc(USBTX, USBRX);
InterruptIn     bp_int(USER_BUTTON);
void ISR_my_pc_reception(void);
void ISR_my_pc_transmission(void);

/* Main Function */
int main() {
    debug_pc.printf("Test\r\n");
    initNRF24();
    
    while(1) {
        Envoie_NRF24();
        debug_pc.baud(115200);
        debug_pc.attach(&ISR_my_pc_reception);
        Reception_NRF24(); 
        bp_int.fall(&ISR_my_pc_transmission);
    }
}

void ISR_my_pc_reception(void){
    if(debug_pc.readable()){ 
         data1=debug_pc.getc(); 
         data2=debug_pc.getc();
         data3 = debug_pc.getc();
         data4=debug_pc.getc();
         data = (data3-48)*10 + data4-48  ; 

            dataToSend[0]= data1-48;
            dataToSend[1]= data2-48;
            dataToSend[2]= data; }
}

void ISR_my_pc_transmission(void){
    if (debug_pc.writable()){
        debug_pc.putc(dataReceived[0]*20/255+10 );   //Affichage de la température
        debug_pc.putc( dataReceived[1]*20.0/255+30); //Affichage de l'humidité *20/255+30
    }
}